from GBaseConn import GBaseConn

with GBaseConn() as conn :   
    cursor = conn.cursor()

    drop = "drop table if exists tab_string"
    cursor.execute(drop)

    create = """
    create table tab_string(
        c_char      char(32767),
        c_nchar     nchar(32767),
        c_varchar   varchar(32765),
        c_nvarchar  nvarchar(32765),
        c_lvarchar  lvarchar(32739),
        c_varchar2  varchar2(32765),
        c_nvarchar2 nvarchar2(32765),
        c_clob2     clob2
    )
    """
    cursor.execute(create)
    
    insert = """
    insert into tab_string(c_char,c_nchar,c_varchar,c_nvarchar,c_lvarchar,c_varchar2,c_nvarchar2,c_clob2) 
    values (?,?,?,?,?,?,?,?)
    """
    cursor.execute(insert,('c_char字段类型char',
                           'c_nchar字段类型nchar',
                           'c_varchar字段类型varchar',
                           'c_nvarchar字段类型nvarchar',
                           'c_lvarchar字段类型lvarchar',
                           'c_varchar2字段类型varchar2',
                           'c_nvarchar2字段类型nvarchar2',
                           'c_clob2字段类型clob2'))
    
    select = "select * from tab_string"
    cursor.execute(select)
    rows = cursor.fetchall()
    # print(rows)
    for row in rows :
        print("字段1 char     的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[0])),len(row[0].encode('utf8')),row[0]))
        print("字段2 nchar    的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[1])),len(row[1].encode('utf8')),row[1]))
        print("字段3 varchar  的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[2])),len(row[2].encode('utf8')),row[2]))
        print("字段4 nvarchar 的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[3])),len(row[3].encode('utf8')),row[3]))
        print("字段5 lvarchar 的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[4])),len(row[4].encode('utf8')),row[4]))
        print("字段6 varchar2 的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[5])),len(row[5].encode('utf8')),row[5]))
        print("字段7 nvarchar2的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[6])),len(row[6].encode('utf8')),row[6]))
        print("字段8 clob2    的类型为：{}，字节长度为：{} ,值为：\"{}\"". format(str(type(row[7])),len(row[7].encode('utf8')),row[7]))

