from GBaseConn import GBaseConn

with GBaseConn() as conn :   
    cursor = conn.cursor()

    drop = "drop table if exists tab_numeric"
    cursor.execute(drop)
    
    create = """
    create table tab_numeric(
        i_serial     serial not null,
        i_smallint   smallint,
        i_int        int,
        i_int8       int8,
        i_bigint     bigint,
        f_smallfloat smallfloat,
        f_float      float,
        d_decimal    decimal(32,20),
        f_decimal_1  decimal(32),
        f_decimal_2  decimal(32),
        d_money      money(32,20)
    )
    """
    cursor.execute(create)

    insert = """
    insert into tab_numeric(i_serial,i_smallint,i_int,i_int8,i_bigint,f_smallfloat,f_float,d_decimal,f_decimal_1,f_decimal_2, d_money) 
    values (0,?,?,?,?,?,?,?,?,?,?)
    """
    # 超过限制时，需要指明类型
    cursor.execute(insert,(32767,
                           2147483647,
                           9223372036854775807,
                           9223372036854775807,
                           float(12345678901234567890),
                           float(12345678901234567890),
                           123456789012.12345678901234567890,
                           9223372036854775807,
                           float(9223372036854775809),
                           123456789012.12345678901234567890
                           ))

    select = "select * from tab_numeric"
    cursor.execute(select)
    rows = cursor.fetchall()
    # print(rows)
    for row in rows:
        print("字段 1 serail         的类型为{},值为：{}" . format(str(type(row[0])),row[0]))
        print("字段 2 samllint       的类型为{},值为：{}" . format(str(type(row[1])),row[1]))
        print("字段 3 integer        的类型为{},值为：{}" . format(str(type(row[2])),row[2]))
        print("字段 4 int8           的类型为{},值为：{}" . format(str(type(row[3])),row[3]))
        print("字段 5 bigint         的类型为{},值为：{}" . format(str(type(row[4])),row[4]))
        print("字段 6 smallfloat     的类型为{},值为：{}" . format(str(type(row[5])),row[5]))
        print("字段 7 float          的类型为{},值为：{}" . format(str(type(row[6])),row[6]))
        print("字段 8 decimal(32,20) 的类型为{},值为：{}" . format(str(type(row[8])),row[7]))
        # decimal(p)被解析成JLong类型，值不应超出int8的上限  
        print("字段 9 decimal(32)    的类型为{},值为：{}" . format(str(type(row[8])),row[8]))
        print("字段10 decimal(32)    的类型为{},值为：{}" . format(str(type(row[9])),row[9]))
        print("字段11 money(32,20)   的类型为{},值为：{}" . format(str(type(row[10])),row[10]))
