from GBaseConn import GBaseConn

with GBaseConn() as conn :   
    cursor = conn.cursor()

    drop = "drop table if exists tab_datetime"
    cursor.execute(drop)

    create = """
    create table tab_datetime(
        i_serial  serial not null,
        t_date    date,
        t_dt_y2d  datetime year to day,
        t_dt_y2s  datetime year to second,
        t_dt_y2f  datetime year to fraction,
        t_dt_y2f1 datetime year to fraction(1),
        t_dt_y2f2 datetime year to fraction(2),
        t_dt_y2f3 datetime year to fraction(3),
        t_dt_y2f4 datetime year to fraction(4),
        t_dt_y2f5 datetime year to fraction(5),
        t_it_d2d  interval day to day,
        t_it_d2h  interval day to hour,
        t_it_d2m  interval day to minute,
        t_it_d2s  interval day to second,
        t_ts      timestamp,
        t_ts0     timestamp(0),
        t_ts1     timestamp(1),
        t_ts2     timestamp(2),
        t_ts3     timestamp(3),
        t_ts4     timestamp(4),
        t_ts5     timestamp(5),
        t_ts6     timestamp(6),
        t_tz      timestamp with time zone,
        t_tz0     timestamp(0) with time zone,
        t_tz1     timestamp(1) with time zone,
        t_tz2     timestamp(2) with time zone,
        t_tz3     timestamp(3) with time zone,
        t_tz4     timestamp(4) with time zone,
        t_tz5     timestamp(5) with time zone,
        t_tz6     timestamp(6) with time zone
    )
    """
    cursor.execute(create)

    insert = """
    insert into tab_datetime(i_serial,t_date,t_dt_y2d,t_dt_y2s,t_dt_y2f,
                             t_dt_y2f1,t_dt_y2f2,t_dt_y2f3,t_dt_y2f4,t_dt_y2f5,
                             t_it_d2d,t_it_d2h,t_it_d2m,t_it_d2s,
                             t_ts,t_ts0,t_ts1,t_ts2,t_ts3,t_ts4,t_ts5,t_ts6,
                             t_tz,t_tz0,t_tz1,t_tz2,t_tz3,t_tz4,t_tz5,t_tz6
                             ) 
                        values(0,?,?,?,?,
                                ?,?,?,?,?,
                                ?,?,?,?,
                                ?,?,?,?,?,?,?,?,
                                ?,?,?,?,?,?,?,?)
    """
    cursor.execute(insert,('2025-03-26','2025-03-26','2025-03-26 14:15:16','2025-03-26 14:15:16.123',
                           '2025-03-26 14:15:16.1','2025-03-26 14:15:16.12','2025-03-26 14:15:16.123','2025-03-26 14:15:16.1234','2025-03-26 14:15:16.12345',
                           '98','98 12','98 12:34','98 12:34:56',
                           '2025-03-26 14:15:16.123456','2025-03-26 14:15:16','2025-03-26 14:15:16.1','2025-03-26 14:15:16.12',
                           '2025-03-26 14:15:16.123','2025-03-26 14:15:16.1234','2025-03-26 14:15:16.12345','2025-03-26 14:15:16.123456',
                           '2025-03-26 14:15:16 +08:00','2025-03-26 14:15:16 +08:00','2025-03-26 14:15:16.1 +08:00','2025-03-26 14:15:16.12 +08:00',
                           '2025-03-26 14:15:16.123 +08:00','2025-03-26 14:15:16.1234 +08:00','2025-03-26 14:15:16.12345 +08:00','2025-03-26 14:15:16.123456 +08:00'
                           ))

    select = "select * from tab_datetime"
    cursor.execute(select)
    rows = cursor.fetchall()
    # print(rows)
    for row in rows:
        print("字段 1 i_serial 的类型为{},值为：{}" . format(str(type(row[0])),row[0]))
        print("字段 2 i_date   的类型为{},值为：{}" . format(str(type(row[1])),row[1]))
        print("字段 3 t_dt_y2d 的类型为{},值为：{}" . format(str(type(row[2])),row[2]))
        print("字段 4 t_dt_y2s 的类型为{},值为：{}" . format(str(type(row[3])),row[3]))
        print("字段 5 t_dt_y2f 的类型为{},值为：{}" . format(str(type(row[4])),row[4]))
        print("字段 6 t_dt_y2f1的类型为{},值为：{}" . format(str(type(row[5])),row[5]))
        print("字段 7 t_dt_y2f2的类型为{},值为：{}" . format(str(type(row[6])),row[6]))
        print("字段 8 t_dt_y2f3的类型为{},值为：{}" . format(str(type(row[7])),row[7]))
        print("字段 9 t_dt_y2f4的类型为{},值为：{}" . format(str(type(row[8])),row[8]))
        print("字段10 t_dt_y2f5的类型为{},值为：{}" . format(str(type(row[9])),row[9]))
        print("字段11 t_it_d2d 的类型为{},值为：{}" . format(str(type(row[10])),row[10]))
        print("字段12 t_it_d2h 的类型为{},值为：{}" . format(str(type(row[11])),row[11]))
        print("字段13 t_it_d2m 的类型为{},值为：{}" . format(str(type(row[12])),row[12]))
        print("字段14 t_it_d2s 的类型为{},值为：{}" . format(str(type(row[13])),row[13]))
        print("字段15 t_ts     的类型为{},值为：{}" . format(str(type(row[14])),row[14]))
        print("字段16 t_ts0    的类型为{},值为：{}" . format(str(type(row[15])),row[15]))
        print("字段17 t_ts1    的类型为{},值为：{}" . format(str(type(row[16])),row[16]))
        print("字段18 t_ts2    的类型为{},值为：{}" . format(str(type(row[17])),row[17]))
        print("字段19 t_ts3    的类型为{},值为：{}" . format(str(type(row[18])),row[18]))
        print("字段20 t_ts4    的类型为{},值为：{}" . format(str(type(row[19])),row[19]))
        print("字段21 t_ts5    的类型为{},值为：{}" . format(str(type(row[20])),row[20]))
        print("字段22 t_ts6    的类型为{},值为：{}" . format(str(type(row[21])),row[21]))
        print("字段23 t_tz     的类型为{},值为：{}" . format(str(type(row[22])),row[22]))
        print("字段24 t_tz0    的类型为{},值为：{}" . format(str(type(row[23])),row[23]))
        print("字段25 t_tz1    的类型为{},值为：{}" . format(str(type(row[24])),row[24]))
        print("字段26 t_tz2    的类型为{},值为：{}" . format(str(type(row[25])),row[25]))
        print("字段27 t_tz3    的类型为{},值为：{}" . format(str(type(row[26])),row[26]))
        print("字段28 t_tz4    的类型为{},值为：{}" . format(str(type(row[27])),row[27]))
        print("字段29 t_tz5    的类型为{},值为：{}" . format(str(type(row[28])),row[28]))
        print("字段30 t_tz6    的类型为{},值为：{}" . format(str(type(row[29])),row[29]))
